/*
** $PROJECT: HyperText-DataType-System
**
** $VER: HyperGuide2HTML.rexx 40.1 (05.01.97)
**
** $AUTHOR: Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
**
** $COPYRIGHT: (C) Copyright 1997 by Stefan Ruppert, All Rights Reserved!
**
** $EMAIL: Stefan.Ruppert@informatik.fh-wiesbaden.de
**
** $HISTORY:
**
** 05.01.97 : 040.001 : initial
**
*/

Options Results

Parse Arg args

/* --------------------------- needed libraries --------------------------- */

Call AddLib('rexxsupport.library',0,-30,0)
Call AddLib('rexxdossupport.library',0,-30,0)

Parse Arg args

rxport        = ''
stem.dest     = ''
stem.verbose  = 1
stem.debug    = 0

template = 'DEST/A,VERBOSE/S,DEBUG/S'

If ReadArgs(args,template,'STEM.') Then Do

   rxport = 'MULTIVIEW.1.1'

   ADDRESS VALUE rxport

   'GETATTR OBJECT=OBJECT FIELD=NODENAME VAR=MAIN'

   If Upper(main) ~= 'MAIN' Then Do
      Say 'This script must be invoked on the main node'
      Exit 10
   End

   'GETATTR OBJECT=OBJECT FIELD=PATH VAR=PATH'

   filename = FilePart(path)
   p = Pos('.hguide',filename)
   If p > 0 Then
      filename = Left(filename,p - 1)
   Else Do
      p = Pos('.guide',filename)
      If p > 0 Then
	 filename = Left(filename,p - 1)
   End

   filename = ToLower(filename)
   basename = filename
   subdir   = AddPart(stem.dest,basename)
   filename = Translate(filename,'__',' "') || '.html'

   file = ToLower(AddPart(stem.dest,filename))
   if stem.verbose Then
      Say 'Converting main node to : ' || file
   'EXPORT TYPE=HTML FILE="' || file || '" ARGS=LOWER'

   done = 0
   do until done
      'NEXTINTERNAL'
      If RC=0 Then Do
	 If ~Exists(subdir) Then
	    Call MakeDir(subdir)

	 If ~Exists(subdir) Then Do
	    Say 'Cannot create sub directory : ' || subdir
	    Exit 10
	 End

	 status = ''
	 Do until status = 'OK'
	    'GETATTR OBJECT=OBJECT FIELD=STATUS VAR=STATUS'
	    If stem.debug Then
	       Say status
	    Call Delay(5)
	 End

	 'GETATTR OBJECT=OBJECT FIELD=NODENAME VAR=NODE'
	 nodefile = node
	 p = Pos('.',nodefile)
	 If p > 0 Then
	    nodefile = Left(nodefile,p - 1)
	 nodefile = nodefile || '.html'

	 file = ToLower(AddPart(subdir,nodefile))

	 if stem.verbose Then
	    Say 'Converting node="' || node || '" to : ' || file

	 'EXPORT TYPE=HTML FILE="' || file || '" ARGS=LOWER'
      End
      Else
	 done = 1
   End
End
Else Do
   /*
   ioerr = GetVar(process,'local')
   Say ioerr
   Say Fault(116,'HyperGuide2HTML')
   */
   Say 'Template : ' || template
End
Exit

ToLower:

   return Translate(Arg(1),'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')

